<template>
  <div class="app-container">
    <!-- 表格 -->
    <el-table v-loading="loading" :data="planList" @selection-change="handleSelectionChange" :height="clientHeight" border :cell-style="tableCellStyle">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="课程内容" align="center" prop="plantName" :show-overflow-tooltip="true"/>
      <el-table-column label="具体内容" align="center" prop="classContent" :show-overflow-tooltip="true"/>
      <el-table-column label="开始日期" align="center" prop="startDate" width="150">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.startDate, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="结束日期" align="center" prop="endDate" width="150">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.endDate, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="实际完成日期" align="center" prop="dateOfCompletion" width="150">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.dateOfCompletion, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="学习状态" align="center" prop="studyState" :formatter="studyStateFormat" width="120"/>
      <el-table-column label="操作" align="center" fixed="right" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-chat-dot-round"
            v-hasPermi="['spec:plan:edit']"
            @click="handleFeedback(scope.row)"
          >反馈</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-document"
            @click="handleDocSuccessor(scope.row)"
            v-hasPermi="['spec:plan:edit']"
          >学员附件</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-document"
            @click="handleDocMentor(scope.row)"
            v-hasPermi="['spec:plan:edit']"
          >学习资料</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <!-- 学习资料对话框 -->
    <el-dialog  :close-on-click-modal="false" v-dialogDrag :title="docMentor.title" :visible.sync="docMentor.open" width="700px" append-to-body>
      <el-table :data="docMentor.commonfileList" border>
        <el-table-column :label="$t('文件名')" align="center" prop="fileName" :show-overflow-tooltip="true">
          <template slot-scope="scope">
            <a  class="link-type"  @click="handleDownload(scope.row)">
              <span>{{ scope.row.fileName }}</span>
            </a>
          </template>
        </el-table-column>
        <el-table-column :label="$t('大小(Kb)')" align="center" prop="fileSize" :show-overflow-tooltip="true" width="80" />
        <el-table-column :label="$t('上传人')" align="center" prop="creator" :show-overflow-tooltip="true" width="120"/>
        <el-table-column :label="$t('操作')" align="center" width="120" class-name="small-padding fixed-width">
          <template slot-scope="scope">
           <el-button
              v-if="scope.row.fileName.endsWith('pdf')||scope.row.fileName.endsWith('xlsx')||scope.row.fileName.endsWith('md')
                 ||scope.row.fileName.endsWith('docx')||scope.row.fileName.endsWith('doc')||scope.row.fileName.endsWith('txt')
                 ||scope.row.fileName.endsWith('jpg')||scope.row.fileName.endsWith('png')||scope.row.fileName.endsWith('csv')
                 ||scope.row.fileName.endsWith('mp4')||scope.row.fileName.endsWith('svg')||scope.row.fileName.endsWith('dwg')
                 ||scope.row.fileName.endsWith('flv')||scope.row.fileName.endsWith('swf')||scope.row.fileName.endsWith('gif')
                 ||scope.row.fileName.endsWith('3gp')||scope.row.fileName.endsWith('mkv')||scope.row.fileName.endsWith('tif')"
              size="mini"
              type="text"
              icon="el-icon-view"
              @click="handleSee(scope.row)"
            > {{ $t('预览') }}</el-button>
            <el-button
              v-if="scope.row.fileName.endsWith('ppt')||scope.row.fileName.endsWith('pptx') "
              size="mini"
              type="text"
              icon="el-icon-view"
              @click="handleSeePPT(scope.row)"
            > {{ $t('ppt预览') }}</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-download"
              @click="handleDownload(scope.row)"
            >{{ $t('下载') }}</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDeleteDocMentor(scope.row)"
            >{{ $t('删除') }}</el-button>
          </template>
        </el-table-column>
      </el-table>

      <div slot="footer" class="dialog-footer">
        <el-button @click="docMentor.open = false">{{ $t('返 回') }}</el-button>
      </div>
    </el-dialog>
    <!-- 学员附件对话框 -->
    <el-dialog  :close-on-click-modal="false" v-dialogDrag :title="docSuccessor.title" :visible.sync="docSuccessor.open" width="700px" append-to-body>
      <el-upload
        ref="docSuccessor"
        :limit="50"
        :headers="docSuccessor.headers"
        :action="docSuccessor.url + '?pType=' + docSuccessor.pType + '&pId=' + docSuccessor.pId"
        :disabled="docSuccessor.isUploading"
        :on-progress="handleFileDocProgressSuccessor"
        :on-success="handleFileDocSuccessSuccessor"
        :auto-upload="true"
        drag
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">
          {{ $t('将文件拖到此处，或') }}
          <em>{{ $t('点击上传') }}</em>
        </div>
      </el-upload>
      <el-table :data="docSuccessor.commonfileList" border>
        <el-table-column :label="$t('文件名')" align="center" prop="fileName" :show-overflow-tooltip="true">
          <template slot-scope="scope">
            <a  class="link-type"  @click="handleDownload(scope.row)">
              <span>{{ scope.row.fileName }}</span>
            </a>
          </template>
        </el-table-column>
        <el-table-column :label="$t('大小(Kb)')" align="center" prop="fileSize" :show-overflow-tooltip="true" width="80" />
        <el-table-column :label="$t('上传人')" align="center" prop="creator" :show-overflow-tooltip="true" width="120"/>
        <el-table-column :label="$t('操作')" align="center" width="120" class-name="small-padding fixed-width">
          <template slot-scope="scope">
          <el-button
              v-if="scope.row.fileName.endsWith('pdf')||scope.row.fileName.endsWith('xlsx')||scope.row.fileName.endsWith('md')
                 ||scope.row.fileName.endsWith('docx')||scope.row.fileName.endsWith('doc')||scope.row.fileName.endsWith('txt')
                 ||scope.row.fileName.endsWith('jpg')||scope.row.fileName.endsWith('png')||scope.row.fileName.endsWith('csv')
                 ||scope.row.fileName.endsWith('mp4')||scope.row.fileName.endsWith('svg')||scope.row.fileName.endsWith('dwg')
                 ||scope.row.fileName.endsWith('flv')||scope.row.fileName.endsWith('swf')||scope.row.fileName.endsWith('gif')
                 ||scope.row.fileName.endsWith('3gp')||scope.row.fileName.endsWith('mkv')||scope.row.fileName.endsWith('tif')"
              size="mini"
              type="text"
              icon="el-icon-view"
              @click="handleSee(scope.row)"
            > {{ $t('预览') }}</el-button>
            <el-button
              v-if="scope.row.fileName.endsWith('ppt')||scope.row.fileName.endsWith('pptx') "
              size="mini"
              type="text"
              icon="el-icon-view"
              @click="handleSeePPT(scope.row)"
            > {{ $t('ppt预览') }}</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-download"
              @click="handleDownload(scope.row)"
            >{{ $t('下载') }}</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDeleteDocSuccessor(scope.row)"
            >{{ $t('删除') }}</el-button>
          </template>
        </el-table-column>
      </el-table>

      <div slot="footer" class="dialog-footer">
        <el-button @click="docSuccessor.open = false">{{ $t('返 回') }}</el-button>
      </div>
    </el-dialog>
    <!-- 反馈对话框 -->
    <el-dialog  :close-on-click-modal="false" v-dialogDrag :title="feedbackDialog.title" :visible.sync="feedbackDialog.open" width="700px" append-to-body>
      <el-form v-if="mentorFeedback != null">
        <h3 style="margin-bottom:20px;">导师反馈</h3>
        <el-form-item>
          <p v-html="mentorFeedback" style="border:1px solid #DFE6EC; overflow:scroll; height:200px;" />
        </el-form-item>
      </el-form>
      <h3>我的心得</h3>
      <el-upload
        ref="docFeedback"
        :headers="docFeedback.headers"
        class="upload-demo"
        :action="docFeedback.url + '?pType=' + docFeedback.pType + '&pId=' + docFeedback.pId"
        :disabled="docFeedback.isUploading"
        :on-progress="handleFileDocProgressFeedback"
        :on-success="handleFileDocSuccessFeedback"
        :auto-upload="true"
        multiple
        :limit="3">
        <el-button
          size="small"
          type="primary"
          style="margin-bottom:10px;margin-top:10px;"
          v-if="feedbackDialog.studyState == 0 || feedbackDialog.studyState == 3"
        >
          点击上传附件
        </el-button>
      </el-upload>
      <el-table :data="docFeedback.commonfileList" border>
        <el-table-column :label="$t('文件名')" align="center" prop="fileName" :show-overflow-tooltip="true">
          <template slot-scope="scope">
            <a  class="link-type"  @click="handleDownload(scope.row)">
              <span>{{ scope.row.fileName }}</span>
            </a>
          </template>
        </el-table-column>
        <el-table-column :label="$t('大小(Kb)')" align="center" prop="fileSize" :show-overflow-tooltip="true" width="120" />
        <el-table-column :label="$t('操作')" align="center" width="120" class-name="small-padding fixed-width">
          <template slot-scope="scope">
             <el-button
              v-if="scope.row.fileName.endsWith('pdf')||scope.row.fileName.endsWith('xlsx')||scope.row.fileName.endsWith('md')
                 ||scope.row.fileName.endsWith('docx')||scope.row.fileName.endsWith('doc')||scope.row.fileName.endsWith('txt')
                 ||scope.row.fileName.endsWith('jpg')||scope.row.fileName.endsWith('png')||scope.row.fileName.endsWith('csv')
                 ||scope.row.fileName.endsWith('mp4')||scope.row.fileName.endsWith('svg')||scope.row.fileName.endsWith('dwg')
                 ||scope.row.fileName.endsWith('flv')||scope.row.fileName.endsWith('swf')||scope.row.fileName.endsWith('gif')
                 ||scope.row.fileName.endsWith('3gp')||scope.row.fileName.endsWith('mkv')||scope.row.fileName.endsWith('tif')"
              size="mini"
              type="text"
              icon="el-icon-view"
              @click="handleSee(scope.row)"
            > {{ $t('预览') }}</el-button>
            <el-button
              v-if="scope.row.fileName.endsWith('ppt')||scope.row.fileName.endsWith('pptx') "
              size="mini"
              type="text"
              icon="el-icon-view"
              @click="handleSeePPT(scope.row)"
            > {{ $t('ppt预览') }}</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-download"
              @click="handleDownload(scope.row)"
            >{{ $t('下载') }}</el-button>
            <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDeleteDocFeedback(scope.row)"
            >{{ $t('删除') }}</el-button>
          </template>
        </el-table-column>
      </el-table>
      <el-form>
        <el-form-item label="我学到了什么？">
          <el-input v-model="feedbackParams.answer1" placeholder="请输入" type="textarea" rows="3"></el-input>
        </el-form-item>
        <el-form-item label="理论学习和平时操作的不同之处？">
          <el-input v-model="feedbackParams.answer2" placeholder="请输入" type="textarea" rows="3"></el-input>
        </el-form-item>
        <el-form-item label="完成此课程后有什么更好的合理化建议？">
          <el-input v-model="feedbackParams.answer3" placeholder="请输入" type="textarea" rows="3"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button :disabled="isButtonDisabled" @click="handleSaveFeedback()" v-if="feedbackDialog.studyState == 0 || feedbackDialog.studyState == 3">{{ $t('保 存') }}</el-button>
        <el-button :disabled="isButtonDisabled" @click="handleSubmitFeedback()" v-if="feedbackDialog.studyState == 0 || feedbackDialog.studyState == 3">{{ $t('提 交') }}</el-button>
        <el-button @click="feedbackDialog.open = false">{{ $t('返 回') }}</el-button>
      </div>
    </el-dialog>
     <!-- 预览对话框 -->
      <el-dialog  :close-on-click-modal="false"  v-loading="loadingFlash"     element-loading-background="rgba(0,0,0,0.2)"                 v-dialogDrag :title="pdf.title" :visible.sync="pdf.open"  width="1300px" :center="true" append-to-body>
      <div style="margin-top: -60px;float: right;margin-right: 40px;">
        <el-button size="mini" type="text" @click="openPdf">{{$t('新页面打开PDF')}}</el-button></div>
      <div style="margin-top: -30px" >
        <iframe id="iFrame" class="iframe-html" :src="pdf.pdfUrl" frameborder="0" width="100%" height="700px" v-if="ppt"></iframe>
      </div>
      <div style="padding: 30px; width: 100%; height: 100%;" >
        <el-carousel class="" ref="carousel"  arrow="always"  v-if="pptView"
                   height="700px"  trigger="click" :autoplay="false" indicator-position="outside">
          <el-carousel-item class="lun_img" v-for="item in imgs" v-bind:key="item" >
            <img :src="item" width="100%" height="100%" object-fit="cover" />
          </el-carousel-item>
        </el-carousel>

      </div>
    </el-dialog>
  </div>
</template>

<script>
import { getFeedbackByPlanId } from "@/api/training/spec/feedback";
import { updateAnswer, addAnswer, getAnswer } from "@/api/training/spec/answer";
import { getPlan, delPlan, addPlan, updatePlan, updatePlan2, exportPlan, importTemplate, listPlanByStaffId } from "@/api/training/spec/plan";
import { allFileList, delCommonfile } from "@/api/common/commonfile";
import { treeselect } from "@/api/system/dept";
import { getToken } from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  name: "MyPlan",
  components: { Treeselect },
  data() {
    return {
        //图片集合   打开关闭按钮 等等
      imgs:[],
      jpgList:[],
      ppt:false,
      pptView:false,
      loadingFlash:false,
      // 按钮是否禁用
      isButtonDisabled: false,
      // 报告附件参数
      docFeedback: {  // 反馈附件
        file: "",
        // 是否显示弹出层（报告附件）
        open: false,
        // 弹出层标题（报告附件）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 报告附件上传位置编号
        ids: 0,
        // 设置上传的请求头部
        headers: { Authorization: "Bearer " + getToken() },
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/common/commonfile/uploadFile",
        commonfileList: null,
        queryParams: {
          pId: null,
          pType: 'docFeedback'
        },
        pType: 'docFeedback',
        pId: null
      },
      docMentor: {  // 学习资料
        file: "",
        // 是否显示弹出层（报告附件）
        open: false,
        // 弹出层标题（报告附件）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 报告附件上传位置编号
        ids: 0,
        // 设置上传的请求头部
        headers: { Authorization: "Bearer " + getToken() },
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/common/commonfile/uploadFile",
        commonfileList: null,
        queryParams: {
          pId: null,
          pType: 'docMentor'
        },
        pType: 'docMentor',
        pId: null
      },
      docSuccessor: { // 学员附件
        file: "",
        // 是否显示弹出层（报告附件）
        open: false,
        // 弹出层标题（报告附件）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 报告附件上传位置编号
        ids: 0,
        // 设置上传的请求头部
        headers: { Authorization: "Bearer " + getToken() },
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/common/commonfile/uploadFile",
        commonfileList: null,
        queryParams: {
          pId: null,
          pType: 'docSuccessor'
        },
        pType: 'docSuccessor',
        pId: null
      },
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      dataListSelections: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 培训计划表格数据
      planList: [],
      // 弹出层标题
      title: "",
      // 操作
      operation: "",
      // 部门树选项
      deptOptions: undefined,
      clientHeight:300,
      // 是否显示弹出层
      open: false,
      // 学习状态字典
      studyStateOptions: [],
      // 反馈对话框参数
      feedbackDialog: {
        // 是否显示弹出层（报告附件）
        open: false,
        // 弹出层标题（报告附件）
        title: "",
        // 学习状态
        studyState: null,
        // 计划id
        planId: null,
      },
      // 反馈参数
      feedbackParams: {
        answer1: "",
        answer2: "",
        answer3: ""
      },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        staffId: null,
        plantName: null,
        startDate: null,
        endDate: null,
        classHour: null,
        studyState: null,
        // approveStatus: 1
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      // pdf文件参数
      pdf : {
          title: '',
          pdfUrl: '',
          numPages: null,
          open: false,
          pageNum: 1,
          pageTotalNum: 1,
          loadedRatio: 0,
      },
      // 导师反馈内容
      mentorFeedback: null,
    };
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
        this.$refs.tree.filter(val);
    }
  },
  created() {
    //设置表格高度对应屏幕高度
    this.$nextTick(() => {
        this.clientHeight = document.body.clientHeight -250
    })
    this.getList();
    this.getTreeselect();
    this.getDicts("st_study_state").then(response => {
      this.studyStateOptions = response.data;
    });
  },
  methods: {
    /** 单元格样式 */
    tableCellStyle(row, column, rowIndex, columnIndex) {
      if (row.column.label === "实际完成日期" && row.row.dateOfCompletion > row.row.endDate) {
        return "background: #FFEEEE"
      }
    },
    /** 反馈处理 */
    handleFeedback(row) {
      this.isButtonDisabled = false;
      // 加载反馈附件
      this.docFeedback.id = row.id;
      this.docFeedback.queryParams.pId = row.id
      this.docFeedback.pId = row.id
      this.getFileListFeedback()
      this.$nextTick(() => {
        this.$refs.docFeedback.clearFiles()
      })
      // 清空导师反馈内容
      this.mentorFeedback = null;
      // 清空答案
      this.feedbackParams.answer1 = "";
      this.feedbackParams.answer2 = "";
      this.feedbackParams.answer3 = "";
      let feedback1 = {};
      feedback1.planId = row.id;
      feedback1.questionId = 1;
      let feedback2 = {};
      feedback2.planId = row.id;
      feedback2.questionId = 2;
      let feedback3 = {};
      feedback3.planId = row.id;
      feedback3.questionId = 3;
      // 获取答案
      getAnswer(feedback1).then(response => {
        let data = response.data;
        if (data != null) {
          this.feedbackParams.answer1 = data.answer;
        }
        return getAnswer(feedback2);
      }).then(response => {
        let data = response.data;
        if (data != null) {
          this.feedbackParams.answer2 = data.answer;
        }
        return getAnswer(feedback3);
      }).then(response => {
        let data = response.data;
        if (data != null) {
          this.feedbackParams.answer3 = data.answer;
        }
        // 获取导师反馈
        return getFeedbackByPlanId(row.id);
      }).then(response => {
        console.log();
        if (response.data != null) {
          this.mentorFeedback = response.data.mentorFeedback;
        }
        this.feedbackDialog.title = row.plantName + "学习情况反馈";
        this.feedbackDialog.planId = row.id;
        this.feedbackDialog.studyState = row.studyState;
        this.feedbackDialog.open = true;
      });
    },
    /** 反馈对话框保存处理 */
    handleSaveFeedback() {
      this.isButtonDisabled = true;
      let feedback1 = {};
      feedback1.planId = this.feedbackDialog.planId;
      feedback1.questionId = 1;
      let feedback2 = {};
      feedback2.planId = this.feedbackDialog.planId;
      feedback2.questionId = 2;
      let feedback3 = {};
      feedback3.planId = this.feedbackDialog.planId;
      feedback3.questionId = 3;
      // 根据计划id和问题id获取答案，有则修改，无则新增
      getAnswer(feedback1).then(response => {
        let data = response.data;
        feedback1.answer = this.feedbackParams.answer1;
        if (data != null) {
          feedback1.id = data.id;
          updateAnswer(feedback1);
        } else {
          addAnswer(feedback1);
        }
      });
      getAnswer(feedback2).then(response => {
        let data = response.data;
        feedback2.answer = this.feedbackParams.answer2;
        if (data != null) {
          feedback2.id = data.id;
          updateAnswer(feedback2);
        } else {
          addAnswer(feedback2);
        }
      });
      getAnswer(feedback3).then(response => {
        let data = response.data;
        feedback3.answer = this.feedbackParams.answer3;
        if (data != null) {
          feedback3.id = data.id;
          updateAnswer(feedback3);
        } else {
          addAnswer(feedback3);
        }
      });
      // this.feedbackDialog.open = false;
      this.msgSuccess("保存成功");
      this.getList();
    },
    /** 反馈对话框提交处理 */
    handleSubmitFeedback() {
      this.isButtonDisabled = true;
      let feedback1 = {};
      feedback1.planId = this.feedbackDialog.planId;
      feedback1.questionId = 1;
      let feedback2 = {};
      feedback2.planId = this.feedbackDialog.planId;
      feedback2.questionId = 2;
      let feedback3 = {};
      feedback3.planId = this.feedbackDialog.planId;
      feedback3.questionId = 3;
      // 根据计划id和问题id获取答案，有则修改，无则新增
      getAnswer(feedback1).then(response => {
        let data = response.data;
        feedback1.answer = this.feedbackParams.answer1;
        if (data != null) {
          feedback1.id = data.id;
          updateAnswer(feedback1);
        } else {
          addAnswer(feedback1);
        }
      });
      getAnswer(feedback2).then(response => {
        let data = response.data;
        feedback2.answer = this.feedbackParams.answer2;
        if (data != null) {
          feedback2.id = data.id;
          updateAnswer(feedback2);
        } else {
          addAnswer(feedback2);
        }
      });
      getAnswer(feedback3).then(response => {
        let data = response.data;
        feedback3.answer = this.feedbackParams.answer3;
        if (data != null) {
          feedback3.id = data.id;
          updateAnswer(feedback3);
        } else {
          addAnswer(feedback3);
        }
      });
      let plan = {};
      plan.id = this.feedbackDialog.planId;
      plan.studyState = 2;
      // 修改学习状态为2学员已提交
      updatePlan2(plan).then(response => {
        // 发送邮件提醒导师

        this.feedbackDialog.open = false;
        this.msgSuccess("提交成功");
        this.getList();
      });
    },
    /** 文件下载处理 */
    handleDownload(row) {
      var name = row.fileName;
      var url = row.fileUrl;
      var suffix = url.substring(url.lastIndexOf("."), url.length);
      const a = document.createElement('a');
      a.setAttribute('download', name);
      a.setAttribute('target', '_blank');
      a.setAttribute('href', process.env.VUE_APP_BASE_API + url);
      a.click();
    },

    /** 报告附件按钮操作 */
    handleDocMentor(row) {
      this.docMentor.id = row.id;
      this.docMentor.title = row.plantName + this.$t('学习资料');
      this.docMentor.open = true;
      this.docMentor.queryParams.pId = row.id
      this.docMentor.pId = row.id
      this.getFileListMentor()
      this.$nextTick(() => {
        this.$refs.docMentor.clearFiles()
      })
    },
    handleDocSuccessor(row) {
      this.docSuccessor.id = row.id;
      this.docSuccessor.title = row.plantName + this.$t('学员附件');
      this.docSuccessor.open = true;
      this.docSuccessor.queryParams.pId = row.id
      this.docSuccessor.pId = row.id
      this.getFileListSuccessor()
      this.$nextTick(() => {
        this.$refs.docSuccessor.clearFiles()
      })
    },
    getFileListMentor() {
      allFileList(this.docMentor.queryParams).then(response => {
        this.docMentor.commonfileList = response;
      });
    },
    getFileListSuccessor() {
      allFileList(this.docSuccessor.queryParams).then(response => {
        this.docSuccessor.commonfileList = response;
      });
    },
    getFileListFeedback() {
      allFileList(this.docFeedback.queryParams).then(response => {
        this.docFeedback.commonfileList = response;
      });
    },
    /** 附件上传中处理 */
    handleFileDocProgressFeedback(event, file, fileList) {
      this.docFeedback.file = file;
      this.docFeedback.isUploading = true;
    },
    handleFileDocProgressMentor(event, file, fileList) {
      this.docMentor.file = file;
      this.docMentor.isUploading = true;
    },
    handleFileDocProgressSuccessor(event, file, fileList) {
      this.docSuccessor.file = file;
      this.docSuccessor.isUploading = true;
    },
    /** 附件上传成功处理 */
    handleFileDocSuccessFeedback(response, file, fileList) {
      // this.$refs.docFeedback.clearFiles(); //上传成功之后清除历史记录
      this.docFeedback.isUploading = false;
      this.$alert(response.msg, this.$t('导入结果'), { dangerouslyUseHTMLString: true });
      // this.docFeedback.id = row.id;
      // this.docFeedback.queryParams.pId = row.id
      // this.docFeedback.pId = row.id
      this.getFileListFeedback();
    },
    handleFileDocSuccessMentor(response, file, fileList) {
      this.docMentor.isUploading = false;
      this.$alert(response.msg, this.$t('导入结果'), { dangerouslyUseHTMLString: true });
      this.getFileListMentor()
    },
    handleFileDocSuccessSuccessor(response, file, fileList) {
      this.docSuccessor.isUploading = false;
      this.$alert(response.msg, this.$t('导入结果'), { dangerouslyUseHTMLString: true });
      this.getFileListSuccessor()
    },
    /** 删除按钮操作 */
    handleDeleteDocFeedback(row) {
      const ids = row.id || this.ids;
      this.$confirm(this.$t('是否确认删除?'), this.$t('警告'), {
        confirmButtonText: this.$t('确定'),
        cancelButtonText: this.$t('取消'),
        type: "warning"
      }).then(function() {
        return delCommonfile(ids);
      }).then(() => {
        this.getFileListFeedback()
        this.msgSuccess(this.$t('删除成功'));
      })
    },
    handleDeleteDocMentor(row) {
      const ids = row.id || this.ids;
      this.$confirm(this.$t('是否确认删除?'), this.$t('警告'), {
        confirmButtonText: this.$t('确定'),
        cancelButtonText: this.$t('取消'),
        type: "warning"
      }).then(function() {
        return delCommonfile(ids);
      }).then(() => {
        this.getFileListMentor()
        this.msgSuccess(this.$t('删除成功'));
      })
    },
    handleDeleteDocSuccessor(row) {
      const ids = row.id || this.ids;
      this.$confirm(this.$t('是否确认删除?'), this.$t('警告'), {
        confirmButtonText: this.$t('确定'),
        cancelButtonText: this.$t('取消'),
        type: "warning"
      }).then(function() {
        return delCommonfile(ids);
      }).then(() => {
        this.getFileListSuccessor()
        this.msgSuccess(this.$t('删除成功'));
      })
    },
    /** 查询培训计划列表 */
    getList() {
      this.loading = true;
      listPlanByStaffId(this.queryParams).then(response => {
        this.planList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 查询部门下拉树结构 */
    getTreeselect() {
      treeselect().then(response => {
        this.deptOptions = response.data;
      });
    },
    /** 学习状态字典翻译 */
    studyStateFormat(row, column) {
      return this.selectDictLabel(this.studyStateOptions, row.studyState);
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: null,
        staffId: null,
        plantName: null,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        startDate: null,
        endDate: null,
        classHour: null,
        classContent: null,
        studyState: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 多选框选中数据 */
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
      this.dataListSelections = selection
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加培养计划";
      this.operation = "add";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getPlan(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改培养计划";
        this.operation = "modify";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updatePlan(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addPlan(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delPlan(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有培养计划数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportPlan(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
    },
    /** 导入按钮操作 */
    handleImport() {
        this.upload.title = "用户导入";
        this.upload.open = true;
    },
    /** 下载模板操作 */
    importTemplate() {
        importTemplate().then(response => {
            this.download(response.msg);
        });
    },
    /** 文件上传中处理 */
    handleFileUploadProgress(event, file, fileList) {
        this.upload.isUploading = true;
    },
    /** 文件上传成功处理 */
    handleFileSuccess(response, file, fileList) {
        this.upload.open = false;
        this.upload.isUploading = false;
        this.$refs.upload.clearFiles();
        this.$alert(response.msg, "导入结果", { dangerouslyUseHTMLString: true });
        this.getList();
    },
    /** 提交上传文件 */
    submitFileForm() {
        this.$refs.upload.submit();
    },
      //文件预览
    openPdf(){
      //ppt就跳路由预览，office就直接打开文件新页面
      const didi={ imgs:this.imgs}
      if( this.pptView==true&&this.ppt==false){
        let routeUrl = this.$router.resolve({
          path: "/cpms/index.html#/pptyulan",
          query:didi
        });
        window.open("/cpms/index.html#/pptyulan?id=" + this.pdf.pdfUrl, '_blank')
        console.log(this.imgs)
      }else {
        window.open(this.pdf.pdfUrl)
      }
    },
    handleSeePPT (row){
      //ppt预览
      this.loadingFlash=true
      this.pdf.open =true
      this.pdf.title = row.fileName
      this.pdf.pdfUrl = row.fileUrl
      this.pptView=true
      this.ppt=false
      const formatDate =new FormData();
      formatDate.append("filepath",row.fileUrl)

      //调用文件预览api
      let res= this.officeConvert.pptConvertCommon(formatDate)

      //查看接受的全局方法的返回结果 console.log(res)
      //利用.then方法接受Promise对象

      res.then((result)=>{
        //关闭加载中
        this.loadingFlash=false

        //成功时直接给地址
        this.videoList = result.data.imagePathList
        //将返回的地址集合遍历添加到绑定的数组中
        this.imgs=[]
        for (var key=0;key<this.videoList.length;key++) {
          this.imgs.push( process.env.VUE_APP_BASE_API+  this.videoList[key]  );
        }
      }).catch(result => {

        //请求失败，关闭loading，pdf地址直接为为空，不显示
        this.pdf.pdfUrl =""
        this.loadingFlash = false;
      })
    },
    handleSee (row){
      //office预览
      this.loadingFlash=true
      this.pdf.open =true
      this.pdf.title = row.fileName
      this.pdf.pdfUrl =""

      this.pptView=false
      this.ppt=true
     //如果是PDF等直接可以打开的就不调接口，否则调用接口
      if(row.fileName.endsWith('pdf')){
             this.pdf.pdfUrl = process.env.VUE_APP_BASE_API + '/pdf/web/viewer.html?file=' + process.env.VUE_APP_BASE_API + row.fileUrl
              this.loadingFlash=false
      }
      else{
      const formatDate =new FormData();
      formatDate.append("filepath",row.fileUrl)

      //调用文件预览api
      let res= this.officeConvert.officeConvertCommon(formatDate)


      //查看接受的全局方法的返回结果 console.log(res)
      //利用.then方法接受Promise对象
      res.then((result)=>{
        //关闭加载中
        this.loadingFlash=false

        if(result.msg.includes("csv")){
          this.pdf.pdfUrl =process.env.VUE_APP_BASE_API+ result.data
          this.$alert(result.msg, this.$t('检查乱码'), { dangerouslyUseHTMLString: true });
          //    this.$message({message: result.msg, center: true,type:'warning',  offset:400, });

        }else if(result.msg.includes("不存在")){
          //文件不存在时提示
          this.pdf.pdfUrl =""
          this.$alert(result.msg, this.$t('预览失败'), { dangerouslyUseHTMLString: true });
          //    this.$message({message: result.msg, center: true,type:'warning',  offset:400, });
          this.pdf.open =false
        }else if(result.msg.includes("不支持此格式")){

          this.pdf.pdfUrl =""
          this.$alert(result.msg, this.$t('预览失败'), { dangerouslyUseHTMLString: true });
          //    this.$message({message: result.msg, center: true,type:'warning',  offset:400, });
          this.pdf.open =false
        } else{
          //成功时直接给地址
          this.pdf.pdfUrl =process.env.VUE_APP_BASE_API+ result.data
        }
        // this.$nextTick(() => {
        //   const iframe = window.frames['iFrame']
        //   const handleLoad = () => {
        //     setTimeout(() => {
        //       const Do = (iframe.contentWindow || iframe.contentDocument)
        //       console.log(Do.document.getElementsByTagName('table')[0])
        //       Do.document.getElementsByTagName('table')[0].style.width = "100%"
        //       Do.document.getElementsByTagName('table')[0].setAttribute("class","table")
        //     }, 500)
        //   }
        //   iframe.addEventListener('load', handleLoad, true)
        // })
      }).catch(result => {

        //请求失败，关闭loading，pdf地址直接为为空，不显示
        this.pdf.pdfUrl =""
        this.loadingFlash = false;

      })
        }


    },
  }
};
</script>
